package com.unitesk.reqcoverage.eclipse.wizards.reports;

import java.awt.GridBagConstraints;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Shell;

import com.unitesk.requality.core.CoreUtils;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.wizards.report.AbstractReportWizardPage;

public class CoverageSourcePage extends AbstractReportWizardPage {
	private Map<Integer,String>elems;
	private String[] elemnames;
	private String selected = null;
	private org.eclipse.swt.widgets.List list;
	public static String COVERAGE_FILE_ID = "com.unitesk.requality.defaultsource";
	protected CoverageSourcePage(String pageName, TreeNode report) {
		super(pageName, report);
    	elems = new HashMap<Integer, String>();
     	elems.put(0,COVERAGE_FILE_ID);
    	Map<String,String> map = Activator.getDefault().getCoverageSourceNames();
    	elemnames = new String[map.keySet().size()+1];
    	elemnames[0] = "From File";
    	int i = 1;
    	String selnow = report.getStringAttributeValue("coverageStorageType");
    	for(String s:map.keySet()){
    		elemnames[i] = map.get(s);
    		elems.put(i++,s);
    		if(selnow!=null && s.equals(selnow))
    			selected = map.get(s);
    	}
	}

	@Override
	public void createControl(Composite parent) {
		Composite par = new Composite(parent, SWT.NONE);
		par.setLayout(new org.eclipse.swt.layout.GridLayout(1,true));
		list = new org.eclipse.swt.widgets.List(par, SWT.SINGLE);
		list.setItems(elems.values().toArray(new String[0]));
		setControl(par);
	}


	@Override
	public void saveChanges() {
		int sel = list.getSelectionIndex();
		if(sel > -1){
			String covType = elems.get(sel);
			if(covType.equals(COVERAGE_FILE_ID))
			{
				Attribute a = getReportNode().getAttribute("coverageStorageSettings");
				if(a!=null)
					getReportNode().removeAttribute(a.getKey());
				a = getReportNode().getAttribute("coverageStorageType");
				if(a!=null)
   					getReportNode().removeAttribute(a.getKey());
//
//	    		FileDialog fd = new FileDialog(getShell());
//	    		fd.setFilterExtensions(new String[]{"*.xml"});
//	    		fd.setFilterNames(new String[]{"Coverage Information File"});
//	    		String oldpath = getReportNode().getStringAttributeValue("coverageFilePath");
//	    		if(oldpath!=null)
//	    			fd.setFileName(oldpath);
//	    		String fname = fd.open();
//	    		if(fname!=null){
//
//	    			IProject proj = TreesTracker.getTracker().getProject(getReportNode().getTreeDB());
//	   				fname = Activator.getDefault().getProjectRelatedPath(fname,proj);
//	  				getReportNode().putAttribute(new Attribute(getReportNode(), AttributeType.STRING,"coverageFilePath",fname));
//	    		}
//	    		else
//	     			return null;
				//TODO file sel page
	    	}else{
	    		Attribute a = getReportNode().getAttribute("coverageFilePath");
				if(a!=null)
					getReportNode().removeAttribute(a.getKey());
//				
//				Shell shell = getShell();
//				String id = covType;
//				ICoverageStorageSource source = Activator.getCoverageSource(id);
//				ICoverageSourceWizard wiz = source.getWizard(getReportNode());
//				Attribute tp = getReportNode().getAttribute("coverageStorageType");
//				Attribute set = null;
//				if(tp != null && tp.getValue().equals(id))
//					set = getReportNode().getAttribute("coverageStorageSettings");
//				//if (wiz == null)
//				//	return null;
//				boolean isOk = false;
//				if(wiz!=null){
//					if(set != null)
//						wiz.setCoverageStorageSettings(getReportNode(),((String)(set.getValue())).split(","));
//					WizardDialog wd = new WizardDialog(shell, wiz);
//					isOk = wd.open() == WizardDialog.OK;
//				}else
//					isOk = true;
//				if (isOk){
//					try{
//						Attribute a = getReportNode().getAttribute("coverageFilePath");
//						if(a!=null)
//							getReportNode().removeAttribute(a.getKey());
//						CoverageStorage cs = CoverageStorage.getStorage(getReportNode().getTreeDB(), source);
//						getReportNode().putAttribute(new Attribute(getReportNode(), AttributeType.STRING,"coverageStorageType",id));
//						if(cs.getSettings(getReportNode())!=null)
//							getReportNode().putAttribute(new Attribute(getReportNode(), AttributeType.STRING,"coverageStorageSettings",CoreUtils.listToString(cs.getSettings(getReportNode()), ",")));
//					}
//	    			catch(Exception e){
//	    				getReportNode().getTreeDB().rollback();
//	    			}
//				}else
//					return;	
	    	}
		}
	}

	public String getSelectedId() {
		int sel = list.getSelectionIndex();
		if(sel>-1)
			return elems.get(sel);
		return null;
	}

}
